<template>
    <v-card color="grey lighten-5">
        <v-card-title>
            <v-btn
                @click="clear"
                :disabled="loading"
                color="white"
                small
            >{{ $t('clear') }}</v-btn>
            <v-spacer></v-spacer>
            <v-btn
                :disabled="loading"
                @click="$emit('confirmed')"
                color="primary"
                small
            >{{ $t('confirm') }}</v-btn>
        </v-card-title>
        <v-card-text>
            <v-list>
                <v-list-item>
                    <v-list-item-content>
                        <v-radio-group
                            v-model="selectedStatus"
                            @change="onStatusChange"
                            class="ml-2 mt-0"
                            row
                            dense
                            hide-details
                        >
                            <v-radio
                                value="attended"
                                :label="$t('attended')"
                                hide-details
                            ></v-radio>
                            <v-radio
                                value="pending"
                                :label="$t('pending')"
                                hide-details
                            ></v-radio>
                        </v-radio-group>
                    </v-list-item-content>
                </v-list-item>
            </v-list>

            <v-divider></v-divider>

            <v-list>
                <div v-if="loading" class="d-flex justify-center">
                    <v-progress-circular indeterminate color="primary"></v-progress-circular>
                </div>
                <v-list-group
                    v-else
                    v-for="selection in selections"
                    v-model="selection.active"
                    :key="selection.text"
                >
                    <template v-slot:activator>
                        <v-list-item-title>{{ selection.text }}</v-list-item-title>
                    </template>

                    <v-list-item-group
                        v-if="selection.field === 'gender'"
                        v-model="selectedGenders"
                        multiple
                    >
                        <v-list-item
                            v-for="gender in selectableGenders"
                            :key="gender.id"
                        >
                            <template v-slot:default="{ active }">
                                <v-list-item-action>
                                    <v-checkbox
                                        :input-value="active"
                                        hide-details
                                    />
                                </v-list-item-action>
                                <v-list-item-content>
                                    <v-list-item-title class="text-capitalize">{{ gender.name }}</v-list-item-title>
                                </v-list-item-content>
                            </template>
                        </v-list-item>
                    </v-list-item-group>
                </v-list-group>
            </v-list>

            <v-divider></v-divider>

            <v-list>
                <v-list-item>
                    <v-list-item-content>
                        <v-text-field
                            v-model="dateRangeText"
                            :label="$t('date_pick_for_me_range')"
                            prepend-icon="mdi-calendar"
                            readonly
                        >
                        </v-text-field>

                        <v-date-picker
                            v-model="selectedDate"
                            @change="onDateRangeChange"
                            range
                        >
                        </v-date-picker>

                    </v-list-item-content>
                </v-list-item>
            </v-list>
        </v-card-text>
    </v-card>
</template>

<script>
    export default {
        name: 'ProductFilters',
        props: [
            'genders',
            'dates,'
        ],
        data: () => ({
            loading: false,
            selectableGenders: [],
            selectedGenders: [],
            selectedStatus: undefined,
            selectedDate: []
        }),
        computed: {
            dateRangeText () {
                return this.selectedDate.join(' ~ ')
            },
            selections() {
                return [
                    {
                        text: this.$tc('gender', 2),
                        field: 'gender',
                        active: false
                    },
                ]
            }
        },
        watch: {
            selectedGenders(ids) {
                const map = ids.map(id => {
                    return this.selectableGenders[id].id
                });
                this.$emit('update:genders', map);
            },
        },
        created() {
            this.loading = true;

            axios.get('api/genders')
                .then(({ data }) => {
                    this.loading = false;
                    this.selectableGenders = data;
                })
                .catch(error => {
                    this.loading = false;
                })
        },
        methods: {
            clear() {
                this.selectedGenders = [];
                this.selectedStatus = undefined;
                this.selectedDate = [];
                this.selections.forEach(selection => {
                    selection.active = false;
                })

                this.$emit('update:dates', this.selectedDate);
                this.$emit('update:status', this.selectedStatus);
            },

            onStatusChange(status) {
                this.$emit('update:status', status);
            },

            onDateRangeChange(dates) {
                this.$emit('update:dates', dates);
            },
        }
    }
</script>

<style scoped>
</style>
